' *************************************************************
'
'          Demo for running TN3270 emulation with VBA
'
' ************************************************************* 

' Global Vars :
' ---------------------
Dim UserName As String
Dim Host As String
Dim UserPassword As String

' Main Program :
' ------------------------
Sub  Main  
	Dim row As Integer
	Dim col As Integer
	Dim Oper As String
	Dim OptArr(3) As String

	Emulation   "TN3270"   ' Set TN3270 as the active emulation
	DlgTitle "TN3270 Demo"
Start:
	User&PassDlg
	EMSetTN3270   Host ,23 , 2 , "ExtendedDS"  
	EMActivate   "AA"   

' This part is designed to automatically logon to a remote host. 
' It is designed to match a specific host pattern and should be changed to 
' match your own host.

	EMWaitText   30 , "USERID   ===>" , 1 , 1 , row , col 
	EMSendKey  UserName
'	EMSendKey   "<ENTER>" 
	EMWaitText   30 , "PASSWORD ===>" , 1 , 1 , row , col 
	EMSendKey UserPassword
	EMSendKey  "<ENTER>" 
	DlgTitle "Wait for Prompt"
	EMWaitText   30 , "RUNNING" , 1 , 1 , row , col 
	If ( row+col  = 0 ) Then 
		Print "ERROR: Could not Log-in, Please try again..."
		Goto Start
	End If	
Again :
	DlgTitle "Commands Selection"
	OptArr(0) = "Profs"
	OptArr(1) = "Filel"
	OptArr(2) = "Logoff"
	OptArr(3) = "Exit"
	MsgRadio  "Please choose required operation" , Oper ,OptArr 
	if ( Oper = "Exit" ) Then
		EMDisconnect  "AA"  
		Stop
	End If
	EMSendKey   Oper  
	EMSendKey   "<ENTER>" 
	If ( Oper = "Logoff" ) Then
		Stop
	else
		EMWaitText  2 , "HOLDING" , 1 , 1 , row , col 
		If ( row+col  > 0 ) Then  EMSendKey  "<Clear>" 
		Goto Again
	End If
		
End Sub   

' Dialog drawing Sub :
' ---------------------------------
Sub User&PassDlg
	DlgStart
		DlgItemAsk   "Host Name :" , Host ,1, 20
		DlgItemAsk   "UserName  :" , UserName ,2, 20 
		DlgItemAskQuiet   "Password   :" , UserPassword ,3, 20 
		DlgInquire
		
		DlgGetItemValue  1 ,Host 
		DlgGetItemValue  2 , UserName 
		DlgGetItemValue  3 , UserPassword 
		
	DlgEnd
End Sub