' *************************************************************
'
'          Demo for running FTP with VBA
'
' ************************************************************* 

' Global Vars :
' ---------------------
Dim $DataArr ( 20 ) As String
Dim Current_Dir As String
Dim host As String
Dim Prev_Dir As String
Dim DirNotFound As String
Dim New_Dir As String
Dim DirExists As String
Dim Del_File As String
Dim FileNotFound As String
Dim login_name As String
Dim password As String
Dim Host_Con As String
Dim Directory As String
Dim FTP_Op As String
Dim L_File As String
Dim R_File As String
Dim Typevar As String
Dim apprep As String

' Main Program :
' ------------------------
Sub Main
Start:
	Current_Dir = ""
	host = "* Not Connected *"
Again:
	DlgTitle "FTP Options"
	FTP_Opt_dlg
	If FTP_Op="Connect" Then
		DlgTitle "Connect to Host"
		Host_Connect_dlg
		FTPConnect  Host , login_name , password 
		If (NM_ResultCode>0) Then
			Print NM_ResultText
			Goto Again
		Else
			Current_Dir = "Root Directory"
		End If
	End If
	If FTP_Op="Show Remote Directory" Then
		Show_Dir_fun
	End If

	If FTP_Op="Change Remote Directory" Then
		Change_Dir_fun
	End If

	If FTP_Op="Make Remote Directory" Then
		Make_Dir_fun
	End If

	If FTP_Op="Delete Remote File" Then
		Delete_File_fun
	End If

	If FTP_Op="Send File" Then
		FTP_Send_fun
	End If

	If FTP_Op="Receive File" Then
		FTP_receive_fun
	End If

	If FTP_Op="Disconnect" Then
		FTPDisconnect 
		Current_Dir = ""
		host = "* Not Connected *"
		Goto Again
	End If

	Goto Again

End Sub

Sub Change_Dir_fun
	Prev_Dir = Current_Dir
	DlgTitle FTP_Op
	Current_Dir = ""
	MsgAsk "Change Directory to...",Current_Dir,20
	FTPChangeDir  Current_Dir 
	If (NM_ResultCode>0) Then
		DirNotFound = Current_Dir
		DirNotFound = DirNotFound & " - Not Found ! "
		Print DirNotFound
		Current_Dir = Prev_Dir
	End If
End Sub

Sub Make_Dir_fun
	New_Dir = ""
	DlgTitle FTP_Op
	MsgAsk "Name of New Directory : ",New_Dir,20
	FTPMakeDir  New_Dir  
	If (NM_ResultCode>0) Then
		DirExists = New_Dir
		DirExists = DirExists & " - Allready Exists !"
		Print DirExists
	End If
End Sub

Sub Delete_File_fun
	DlgTitle FTP_Op
	MsgAsk "FIle to Delete : ",Del_File,20
	FTPDeleteFile  Del_File 
	If (NM_ResultCode>0) Then
		FileNotFound = Del_File
		FileNotFound = FileNotFound & " - Not Found !"
		Print FileNotFound
	End If
End Sub

Sub FTP_receive_fun
	DlgTitle "FTP Receive"
	File_Name_dlg
	FTPReceive  L_File ,R_File , Typevar , apprep 
	If (NM_ResultCode>0) Then
		Print NM_ResultText
	End If
End Sub

Sub FTP_Send_fun
	DlgTitle "FTP Send"
	File_Name_dlg
	FTPSend  L_File , R_File , Typevar , apprep
	If (NM_ResultCode>0) Then
		 Print NM_ResultText
	End If
End Sub

Sub Show_Dir_fun
	FTPDirToFile  "" , "dir.txt"
	If (NM_ResultCode>0) Then
		 Print "The Sellected Directory is Empty"
	Else
		SysWinExec("NotePad dir.txt")
		Kill "dir.txt"
	End If
End Sub

Sub Host_Connect_dlg
DlgStart
	host= ""
	login_name= ""
	DlgItemAsk "Host Name: ",host,1,20
	DlgItemAsk "Login Name:",login_name,2,20
	pass = ""
	password = ""
	DlgItemAskQuiet "Password:   ",pass,3,20
	DlgInquire

	DlgGetItemValue 1 , host
	DlgGetItemValue 2 , login_name 
	DlgGetItemValue 3 , pass
	StrEncrypt pass,password
DlgEnd
End Sub

Sub FTP_Opt_dlg
DlgStart
	Host_Con = "Connected To Host : "
	Host_Con = Host_Con & host
	DlgItemType Host_Con
	Directory = "Current Directory : "
	Directory = Directory & Current_Dir
	DlgItemType Directory
	SysReDim $DataArr , 7 
	$DataArr( 0 ) = "Connect"
	$DataArr( 1 ) = "Show Remote Directory"
	$DataArr( 2 ) = "Send File"
	$DataArr( 3 ) = "Receive File"
	$DataArr( 4 ) = "Change Remote Directory"
	$DataArr( 5 ) = "Make Remote Directory"
	$DataArr( 6 ) = "Delete Remote File"
	$DataArr( 7 ) = "Disconnect"
	DlgItemRadio "Choose FTP Operation",FTP_Op,1,$DataArr
	DlgInquire
	DlgGetItemValue 1 , FTP_Op 
DlgEnd
End Sub

Sub File_Name_dlg
DlgStart
	DlgItemAsk "Local File:  ",L_File,1,30
	DlgItemAsk "Remote File:",R_File,2,30
	SysReDim $DataArr , 1
	$DataArr( 0 ) = "Ascii"
	$DataArr( 1 ) = "Binary"
	DlgItemRadio "File TypeVar",Typevar,3,$DataArr
	SysReDim $DataArr , 1
	$DataArr( 0 ) = "Append"
	$DataArr( 1 ) = "Replace"
	DlgItemRadio " If File Exists:",apprep,4,$DataArr
	DlgInquire
	DlgGetItemValue 1 , L_File 
	DlgGetItemValue 2 , R_File 
	DlgGetItemValue 3 , Typevar
	DlgGetItemValue 4 , apprep
DlgEnd
End Sub


